echo off
cls
if '%1'=='' goto NeedDrive

if not exist cmfiler.com goto WrongDir
if exist cmfiler.ovy goto RightDir

:NeedDrive
echo You must specify the drive letter into which to install CMFiler; e.g.
echo.
echo INSTALL C
echo.
echo Do not include a colon after the drive letter. Please try again.
echo.
goto TheEnd

:WrongDir
echo INSTALL.BAT is unable to find the CMFiler program files.
echo.
echo Make sure that all the files from the original CF603.ZIP, CF603.EXE
echo or CMFILE.ZIP compression are in the same directory, and that that
echo directory is selected as the DOS current directory before running
echo INSTALL.BAT.
echo.
pause
goto TheEnd

:RightDir
echo        *****  CMFiler Ver 6.03 Installation *****
echo.
echo This batch file creates the directory %1:\CF603 and copies to it
echo the files in the CMFiler Ver 6.03 fileset.
echo.
if exist %1:\DOS\CHOICE.COM goto GetChoice
pause
goto InstallNow

:GetChoice
%1:\DOS\CHOICE.COM Proceed with installation 
if errorlevel 2 goto TheEnd

:InstallNow
cls
echo Installing CMFiler Ver 6.03 to %1:\CF603
echo.
echo Creating %1:\CF603
echo.
md %1:\cf603
copy BRIEF.TXT %1:\CF603\BRIEF.TXT
if not exist %1:\cf603\BRIEF.TXT goto FailDir
echo Copying files. . .
echo.
copy *.* %1:\cf603
echo Creating CF603.BAT on %1:\
echo %1:\CF603\CMFILER.COM >%1:\CF603.BAT
echo.
echo File copying complete. Note any error messages, then
pause
cls
if not exist %1:\CF603\CMFILER.COM goto NoProgs
if exist %1:\CF603\CMFILER.OVY goto OKProgs

:NoProgs
echo Program files did not copy. Installation aborted.
goto TheEnd

:OKProgs
echo Program files apparently copied successfully.
echo.
echo To run CMFiler at the DOS prompt, you may:
echo.
echo   (1) type:
echo         %1:\CF603\CMFILER
echo.
echo      or;
echo.
echo   (2) just type:
echo         %1:\CF603
echo.
echo If you have an existing .CFG file from a previous version, just
echo copy it into the %1:\CF603 directory over any new .CFG file the
echo new CMFiler may have made. Be sure the .CFG file has the same name
echo (i.e., CMFILER or CF) as the .COM file.
echo.
pause
cls
echo The files in the directory %1:\CF603 include CMFILER.PIF and CMFILER.ICO
echo files for running CMFiler under Windows 3.1 or Windows 95. The CMFILER.PIF
echo file assumes CMFiler has been installed in the C drive. If you used
echo some other drive, edit CMFILER.PIF before using it.
echo.
pause
echo For Windows 3.1:
echo.
echo To add CMFiler to a program group, go to the Windows Program Manager, and
echo double click on the desired group.  Then, in the Program Manager menu bar,
echo click on File, and New...  Then click the Program Item bullet, and OK.
echo.
echo Fill in the data in the next menu as follows, moving the cursor from
echo each line to the next using your mouse and clicking:
echo.
echo Description:  CMFiler
echo Command Line: %1:\CF603\CMFILER.COM
if %1==C goto W31C
if not %1==c goto W31NotC

:W31C
echo           [or %1:\CF603\CMFILER.PIF]
:W31NotC
echo Working Directory: %1:\  [or whatever you would like CMFiler to start in]
echo Shortcut Key: [Optional. I use Ctrl+Alt+C]
echo Also decide if you want CMFiler to start minimized. I leave this off.
echo.
echo Then click on the Change Icon... button.  Windows will tell you there are
echo no available icons for this file.  Click OK, then, on the File Name line
echo in the next menu, type %1:\CF603\CMFILER.ICO and click on OK twice.
echo The CMFiler icon should appear in the CMFiler Properties box.
echo Click OK on the Program Item Properties menu, and the CMFiler icon should
echo appear in the program group. Just double click on it to run.
echo.
pause
cls
echo For Windows 95:
echo.
echo To add CMFiler to a program folder as a shortcut, click on Start,
echo go to Settings and click on Taskbar...  Click on the
echo Start Menu Programs tab, click on Add, type in %1:\CF603\CMFILER.COM
if %1==C goto W95C
if not %1==c goto W95NotC

:W95C
echo [or %1:\CF603\CMFILER.PIF]
:W95NotC
echo and click on Next.
echo.
echo Select a folder to put the CMFiler shortcut into and click on Next.
echo If you want CMFiler on your desktop when Windows 95 starts up, click on
echo the folder Desktop.  If you want Windows 95 to start up with
echo CMFiler already running, click on the Startup folder.  Otherwise,
echo pick an appropriate folder in Programs to put it in.
echo.
echo Select a name for the shortcut (CMFiler will probably be the default),
echo and click OK.
echo.
pause
goto TheEnd

:FailDir
echo.
echo Unable to create %1:\CF603. Please specify another drive.

:TheEnd
echo.
echo on
