
/* docp.c */
void main(int argc, char *argv[]);
void check_and_format_dirs(int argc, char *argv[], char *src_dir, char *dst_dir);
void check_target_removeable(char *dst_dir);
void check_if_dirs_compatible(char *src_dir, char *dst_dir);
void check_if_dir_exists(char *dir, int is_dest);
void create_dir(char *dir);
int just_disk(char *dir);
void change_disk(char *dir, char *cur_dir);
void copy_files(char *src_dir, char *dst_dir, char *file_spec[], int num_args, void *file_buf, unsigned long buf_size);
void report_not_copied(char *src_file);
void zap_target(char *dst_dir, int print_banner);
void build_hash_tab(char *dir, ENTRY *hash_tab[], int num_args, char *file_spec[]);
void add_to_hash_tab(char *dir, ENTRY *hash_tab[], int from_file_poss, int num_args, char *file_spec[]);
void take_from_hash_tab(char *dir, ENTRY *hash_tab[], int num_args, char *file_spec[]);
void get_file_spec(char *buf, char *file_spec[], int i);
void print_fdate(unsigned fdate);
void print_ftime(unsigned ftime);
void add_entry(struct ffblk *fblk, ENTRY *hash_tab[]);
char *get_first(int *index);
char *get_next(int *index);
void move_Ptr(int *index);
short get_fmode(char *src_file);
void clear_archive_bits(char *src_dir);
void clear_hash_tab(ENTRY *hash_tab[]);
void remove_entry(char *file, ENTRY *hash_tab[]);
ENTRY *find_entry(char *file, ENTRY *hash_tab[]);
void copy_sub_dirs(char *src_dir, char *dst_dir, char *file_spec[], int num_args, void *file_buf, unsigned long buf_size);
int should_dir_copy(char *src_dir, char *dst_dir, char *name, char *new_src_dir, char *new_dst_dir);
int should_file_copy(char *file, char *src_file);
long cmptime_entry(ENTRY *a, ENTRY *b);
int within_date_range(ENTRY *src);
int file_exists(char *name);
void *get_file_buf(unsigned long *buf_size);
void copy_file(ENTRY *ptr, char *dst_file, char *src_file, unsigned long buf_size);
int rename_file(ENTRY *ptr, char *src_file, char *dst_file);
void copy_file_to_buffer(int src_handle, ENTRY *ptr, char *src_file, char *dst_file, struct ftime *ftime_buf, long fsize, short fattr);
void copy_file_unbuffered(int src_handle, ENTRY *ptr, char *src_file, char *dst_file, long fsize, struct ftime *ftime_buf, short fattr, unsigned long buf_size);
int ensure_dest_dir_exist(char *dst_file);
int write_to_fit_disk(int dst_handle, char *dst_file, void *file_buf, unsigned max_bytes_write);
void target_disk_full(char *dst_file, int dst_handle);
void clean_up_and_exit(void);
void copy_file_contents(int src_handle, int dst_handle, char *src_file, char *dst_file, unsigned long buf_size);
int ok_to_retry(void);
void write_buffer(void *file_buf);
void *get_header_info(void *file_buf, ENTRY **ptr, char *src_file, char *dst_file, struct ftime *ftimebuf, long *fsize, short *fattr);
int write_dest_file(int *dst_handle, char *dst_file, void *file_buf, long file_size, int fattr);
int open_dest_file(int *handle, char *name, unsigned modes);
void usage(void);
void get_flags(char *argv[], int argc);
void set_defaults(void);
void check_flags(void);
void show_doc(void);
void set_Ftime(char *time_str);
void store_time(TIME *time);
void check_time(TIME *time, char *time_arg);
void bad_time(char *time_arg);
void set_Fdate(char *date_str);
void convert_date_str(DATE *date, char *date_str);
char *get_field(char *string, int *field);
void set_todays_date(void);
void get_todays_date(DATE *date);
void store_date(DATE *date);
void check_date(DATE *date, char *date_str);
void bad_date(char *date_str);
void build_stdin_file_list(int *num_args);
void add_to_stdin_list(char *s);
