@ECHO OFF
ECHO OFF

REM  When this batch file is called, the following symbols are defined:
REM  %1   If this contains the word FROMSAFE, we know we came from SAFE.BAT
REM  %2   The name of the oldest ZIP file on the A: drive
REM  %3   (Optional) The file mask for the files to be backed up
REM       If no mask is given, all files are backed up

REM 
REM Make sure we came from SAFE.BAT
REM
IF (%1) == (FROMSAFE) GOTO EOCKSAFE
ECHO This batch file is designed to be called by SAFE.BAT.  Nothing done.
GOTO QUIT
:EOCKSAFE

REM 
REM Get the go-ahead
REM
IF (%3) == () GOTO SHOWALL
IF (%3) == (*.*) GOTO SHOWALL
GETKEY Backup %3 to %2?  YN
IF ERRORLEVEL 2 GOTO QUIT
GOTO EOCKOK

:SHOWALL
DIR /W
GETKEY Back up this directory to %2? YN
IF ERRORLEVEL 2 GOTO QUIT

:EOCKOK

REM 
REM Rename original, then make temporary directory
REM
MD SAFE$$$$
CD SAFE$$$$

REM 
REM Make the archive
REM
IF     (%3) == () PKZIP -a SAFE0 ..\*.*
IF NOT (%3) == () PKZIP -a SAFE0 ..\%3

REM 
REM PKZIP doesn't return an ERRORLEVEL (last time we checked) but in case
REM it ever does, let's check it.
REM
IF ERRORLEVEL 1 GOTO PROBLEM

REM 
REM Copy the file to the diskette, then clean up
REM
COPY SAFE0.ZIP %2
CD ..
ECHO Y | DEL SAFE$$$$\*.*
RD SAFE$$$$
CLS
ECHO 
ECHO ۱    BACKUP  COMPLETE!    ۱
ECHO 
PINNACLE X
GOTO QUIT

REM 
REM Trouble
REM
:PROBLEM
CLS
ECHO   SAFE -- THE QUICK BACKUP UTILITY  
ECHO                                                                          
ECHO               An error has occured.  The temporary directory             
ECHO               SAFE$$$$ may contain some extraneous files.                
ECHO                                                                          
ECHO 

REM 
REM The End
REM
:QUIT
